/**
 * Container class to hold information about GTerms, which are important expressions in GSentences.
 * @see GSentence
 */
public class GTerm {

	public String id;
	public String lex;
	public String sem;
	public GSentence parent;

	/**
	 * To construct a term, it has to belong to a sentence.
	 * @param p the parent sentence
	 */
	public GTerm (GSentence p) {
			  this.parent = p;
	}

	/**
	 * Set the identificator of this term
	 * @param s identificator string
	 */
	public void setID(String s){
		id = s;
	}

	/**
	 * Set the lexical representation of this term
	 * @param s the lexical representation
	 */
	public void setlex(String s){
		lex = s;
	}

	/**
	 * Set the semantic representation of this term
	 * @param s the semantic representation
	 */
	public void setsem(String s){
		sem = s;
	}

	/**
	 * Echo this Term to stdout.
	 */
	public void hello(){
		System.out.println("Term ID: "+id);
		System.out.println("Term LEX: "+lex);
		System.out.println("Term SEM: "+sem);
	}

}
