#!/usr/bin/perl

# Harald Svik, harals@stud.ntnu.no
# CREATED  060207 10:55.
# MODIFIED 060213 14:45.

#
# Purpose: Extract TQL from a dump-file

package tqlextraction;

my $medline = 0;
my $tqlstate = 0;
my $blankline = 0;
my $tqlcounter = 1;
my $inputcounter = 0;
my @tql = ();
my $prev_abstract = 0;

while (<>) {
   if ($_ =~ /^% TQL:\s+$/) # enter tql
   {
	 $inputcounter++;
    $tqlstate = 1; 
   }
	elsif ($_ =~ /^\s+$/) # blank lines
	{
      if ( ($tqlstate == 1) && ($blankline == 0) )
      {
			$blankline = 1;
		} 
		elsif ( ($tqlstate == 1) && ($blankline == 1) )
		{
			finalize();
		}
		else
		{
			# ignore
		}
	} 
   elsif ( ($_ =~ /^\.{72}$/) && ($tqlstate == 1) )
   {
		finalize();
	} 
   elsif ($tqlstate == 1)
   {
		@tql = (@tql,$_);	
	} 
   elsif ($_ =~ /^--- Incomprehensible at .*$/)
   {
		$inputcounter++;
   }
   elsif ($_ =~ /^--- Incomprehensible words:  \[(.*)\]$/)
   {
		$inputcounter++;
   }
   elsif ($_ =~ /^--- Sentence is too difficult ---/)
   {
		$inputcounter++;
   }
   elsif ($_ =~ /^--- Please use a complete sentence ---/)
   {
		$inputcounter++;
	}
   elsif ($_ =~ /^#.KEEP .*?MEDLINE .*?(\d+)/)
   {
		if ( $prev_abstract == 1 ) { print "</abstract>\n"; }
		print "<abstract medlineid='$1'>\n";
	}
   else 
   {
    # ignore everything else
   }
} 

sub finalize {

	# echo tql to stdout	
	print "<tql input='$inputcounter' block='$tqlcounter'>\n";
 	foreach (@tql) 
	{
  		print "$_";
 	}
	print "</tql>\n\n";

	# unset state and carry on
 	@tql = ();
	$tqlstate = 0;
	$blankline = 0;
	$tqlcounter++;
}



print "</abstract>\n";

# class for event extraction
# package evex;
# 
# sub new
# {
# 	my ($class) = @_;
# 	my $self = {
# 		_tql => undef
# 	};
#    bless $self, $class;
# 	return $self;
# }
# 
# # accessor method 
# sub tql {
#     my ( $self, $tql ) = @_;
#     $self->{_tql} = $tql if defined($tql);
#     return $self->{_tql};
# }
# 
# 
# 
